/***************************************************************************/
/*                       THintBox version 0.65                             */
/* ----------------------------------------------------------------------- */
/* What is it: This is a quick implementation of the HintBox's that you can*/
/* ----------- see in many Lotus products (for instance Lotus SmartSuite). */
/*                                                                         */
/* How to install it: Go to the "Component" Menuitem and select "Install   */
/* ------------------ Component...". Click the "Browse" button next to the */
/*                    "Unit file name:". Choose "HintBox.cpp".             */
/*                    Choose the apporpriate package to install THintBox in*/
/*                    to, from the "Package file name" combobox (normally: */
/*                    dclusr35.bpk or dclusr40.bpk)                        */
/*                    THintBox will register it self in the "Samples"      */
/*                    palette.                                             */
/*                                                                         */
/* How to use it: Just drop it on to the Form you're working with and work */
/* -------------- on.                                                      */
/*                                                                         */
/* What does it cost: Nothing. It's free of charge for any usage! :-)      */
/* ------------------                                                      */
/*                                                                         */
/* Which version of C++ Builder is it tested with: 3 and 4. Should work    */
/* ----------------------------------------------- with version 1 too.     */
/*                                                                         */
/* Disclaimer:                                                             */
/* -----------                                                             */
/* THintBox is provided "AS IS" without warranty of any                    */
/* kind, either expressed or implied, including but not limited            */
/* to the implied warranties of merchantability and fitness                */
/* for a particular purpose. In no event shall Cramon Utilites             */
/* be liable for any damages whatsoever including direct, indirect,        */
/* incidental, consequential, loss of business profits or                  */
/* special damages, even if Cramon Utilities has been advised              */
/* of the possibility of such damages.                                     */
/* You may use THintBox free of charge in any application you make         */
/* be it freeware, shareware or commercial. If you change the sourcecode   */
/* of THintBox you must include this text and clearly state which parts    */
/* are changed by you and that this is not the original version.           */
/* If you would like your changes in the "official" version please send    */
/* the updated source file(s) to me and I'll update my sourcecode (you'll  */
/* ofcourse get credit for all changes you've made to THintBox.            */
/*                                                                         */
/* Author..: Jeppe Cramon                                                  */
/* Company.: Cramon Utilities                                              */
/* WWW.....: http://www.cramon.dk                                          */
/* E-mail..: jeppe@cramon.dk                                               */
/* (C) Copyright 1999 Cramon Utilities                                     */
/*                                                                         */
/* ----------------------------------------------------------------------- */
/* Date         Comment                                 Programmer         */
/* 05/03-1999   Created the first version (0.20)        Jeppe Cramon       */
/* 05/04-1999   Version 0.21. Fixed a problem with the  Jeppe Cramon       */
/*              space getting drawn on the next line                       */
/*              when it should have been removed (as a                     */
/*              part of the WordWrap)                                      */
/* 05/08-1999   Changed inheritance from TPanel, to     Jeppe Cramon       */
/*              TCustomControl. Changed from Caption to                    */
/*              Lines, just like in a TMemo, so now you                    */
/*              can have multiple lines with WordWrap                      */
/*              instead only one.                                          */
/*              NEW: You can now set ShadowSize.                           */
/* 05/09-1999   Add support for HTML tags. This means   Jeppe Cramon       */
/*              that THintBox, now is able to display                      */
/*              HTML formattet text. So far only a very                    */
/*              minor fraction of the HTML standard is                     */
/*              supported:                                                 */
/*               Center Text - <CENTER>..Text..</CENTER>                   */
/*               Line break  - <BR>                                        */
/*               Bold        - <B>..Text..</B>                             */
/*               Italic      - <I>..Text..</I>                             */
/*               Underline   - <U>..Text..</U>                             */
/*               StrikeOut   - <STRIKE>..Text..</STRIKE>                   */
/*              NEW: You can now also choose if THintBox                   */
/*                   should draw it's hintbox. Setting                     */
/*                   the DrawHintBox property to false                     */
/*                   will make it look like a label, but                   */
/*                   with all the HintBox features ;-)                     */
/***************************************************************************/


//---------------------------------------------------------------------------
#ifndef HintBoxH
#define HintBoxH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
class PACKAGE THintBox : public TCustomControl
{
private:
    void __fastcall DrawBox();      // Normal DrawBox (without HTML Formatting)
    void __fastcall DrawBoxEx();    // DrawBox with HTML Formatting
    void __fastcall Parse();
    void __fastcall ParseLine(AnsiString asText);
    int __fastcall FindNext(AnsiString asText, AnsiString asFind, int iOldIndex=1);
    TSize __fastcall TextExtentEx(AnsiString asTestText);
    void __fastcall TextOutEx(int X, int Y, const AnsiString asTextOut);

    TColor   BkColor;
    TColor   ShColor;
    Classes::TStrings* FLines;
    int      iShadowSize;
    bool     bHTMLFormatting;
    bool     bDrawBox;

    TList*       CenterList;        // Contains result of which lines in the TextList that should be centered
    TStringList* TextList;          // Used in the parsing of FLines
protected:
    virtual void __fastcall Paint();
    void __fastcall SetLines(Classes::TStrings* Value);
    void __fastcall SetLines(TFont* Value);
    void __fastcall SetColor(TColor Value);
    void __fastcall SetShadowColor(TColor Value);
    void __fastcall SetShadowSize(int Value);
    void __fastcall SetHTMLFormatting(bool Value);
    void __fastcall SetHintBox(bool Value);
public:
    __fastcall THintBox(TComponent* Owner);
    __fastcall ~THintBox();
    void __fastcall Update();
__published:
    __property TColor Color = {read=BkColor, write=SetColor, stored=IsColorStored, default= clInfoBk};
    __property TColor ShadowColor = {read=ShColor, write=SetShadowColor, stored=IsColorStored, default= clGray};
    __property Classes::TStrings* Lines = {read=FLines, write=SetLines};
    __property int ShadowSize = {read=iShadowSize, write=SetShadowSize, default= 4};
    __property bool HTMLFormatting = {read=bHTMLFormatting, write=SetHTMLFormatting, default= true};
    __property bool DrawHintBox = {read=bDrawBox, write=SetHintBox, default= true};

    __property Align ;
    __property DragCursor ;
    __property DragMode ;
    __property Enabled ;
    __property Ctl3D ;
    __property Font ;
    __property ParentColor ;
    __property ParentCtl3D ;
    __property ParentFont ;
    __property ParentShowHint ;
    __property PopupMenu ;
    __property ShowHint ;
    __property TabOrder ;
    __property TabStop ;
    __property Visible ;
    __property OnClick ;
    __property OnDblClick ;
    __property OnDragDrop ;
    __property OnDragOver ;
    __property OnEndDrag ;
    __property OnEnter ;
    __property OnExit ;
    __property OnMouseDown ;
    __property OnMouseMove ;
    __property OnMouseUp ;
    __property OnResize ;
    __property OnStartDrag ;

};
//---------------------------------------------------------------------------
#endif
